      PROGRAM COSCORR_Onlyraw
C**********************
C This program is only for cosine correction.
C no AERONET collocation since collocation will be done after cosine correction
C**********************

      implicit none
      integer nobs
      parameter(nobs=285166)
      character colan*1
      character site*4
      character instnum*3
      integer i, j, k, wv, indx, m


      real*4 nday(74),eqt(74),dec(74),iday
      real*4 dtor, frac, degpday, E_CCen, dayph, pi
      real*4 eqtime, decang, sunlat, sunlon, alon, alat
      real*4 xx, yy, zz, t0, t1, p0, p1, dd, time
      real*4 zenith(nobs),azimuth(nobs),elevation(nobs),soldist(nobs)
      real*4 orig_zenith(nobs)      
      real*4 declenation(nobs),airmass(nobs),orig_airmass(nobs)
      real*4 zenith_calc(nobs),zenith_new(nobs),tilt_NS,tilt_EW
      
      real*8 rawvol(nobs,31),doy_table(31,13),nthday_table(366,113)
      real*8 ydate(113),foy !final(julian) day of year
      
      integer year(nobs),month(nobs),date(nobs),hour(nobs)
      integer mins(nobs),secs(nobs) 
      integer jday(nobs)
	
      real*8 doy(nobs),jday_frac(nobs)      

      real*4 cos_tab(358,16),zenithN(90),zenithS(90),zenithE(90)
      real*4 zenithW(90)
      real*4 N_CC(90),S_CC(90),E_CC(90), W_CC(90)

      real*4 zenith1(90), zenith2(90), cc_table1(90), cc_table2(90)
      real*4 theta1, theta2, ccintptheta1, ccintptheta2, ccintp
      real*4 phi1, phi2

      real*4 diff_tot_ratio, vbias, v_total, fdiso(7)
      real*4 vt_corr(nobs,7),vdirn_corr(nobs,7),vdiff_corr(nobs,7)
      real*4 vt(nobs,7),vdirn(nobs,7),vdiff(nobs,7)      
      real*4 ft, fracday, nthday_round

      real*4 dummy,var1,var2      

      site='MD22'
      instnum='582'

      fdiso(1)=1.01989
      fdiso(2)=1.00407
      fdiso(3)=1.0057
      fdiso(4)=1.00674
      fdiso(5)=1.00891
      fdiso(6)=1.0109
      fdiso(7)=1.01951
C=====================PRINTING OUTPUT====================================
C=====================PRINTING HEADER====================================

c		write(*,'(a)')'Number of Lines in header: 15'
c		write(*,'(a)')'Site Code: site, (unitless), Location ID' //
c     &			   '(State Abbrev plus numeric id)'
c		write(*,'(a)')'Serial Number: SN, (unitless)'
c		write(*,'(a)')'UTC Date-Time: UYYY,UM,UD,Uh,Um,Us,'//
c     &			  'UYYY is year, UM is month, UD is day,'//
c     &			  'Uh is hour, Um is minute, Us is seconds,'//
c     &			  '24-hour clock, UTC'
c     		write(*,'(a)')'Local Date-Time: LYYY,LM,LD,Lh,Lm,Ls,'//
c     &			  'LYYY is year, LM is month, LD is day,'//
c     &			  'Lh is hour, Lm is minute, Ls is seconds,'//
c     &			  '24-hour clock, Local Standard Time'
c		write(*,'(a)')'Local Day of year: LDy,'//
c     &			      '(Days, Local Standard Time)'
c		write(*,'(a)')'Azimuth: Azi, (degrees positive'//
c     &			      'east of north)'
c		write(*,'(a)')'Elevation: Elev, (degrees)'
c		write(*,'(a)')'Zenith angle: Zen, (degrees)'
c		write(*,'(a)')'Declination: Decl, (degrees)'
c		write(*,'(a)')'Air mass: Airmass, (unitless)'
c		write(*,'(a)')'Solar distance: Soldist, (unitless)'
c		write(*,'(a)')'Uv channel data:  www(Tot), www(Dif),'//
c    & 			      'www(Dir), (millivolts) where www is'//
c     &			      'the wavelength in nanometers'
c		write(*,'(a)')'Quality Control code: QC Code,'//
c     &			      '(unitless), semi colon delimited'//
c     &			      'description of known problems with'//
c     &			      'data, zero if none'
c		write(*,'(a)')'Site,SN,UYYY,UM,UD,Uh,Um,Us,LYYY,LM,'//
c     &		'LD,Lh,Lm,Ls,DoY,Azi,Elev,Zen,Decl,Airmass,Soldist,'//
c     & 		'300(ToT),305(Tot),311(Tot),317(Tot),325(Tot),'//
c     &		'332(Tot),368(Tot),300(Dif),305(Dif),311(Dif),'//
c     &		'317(Dif),325(Dif),332(Dif),368(Dif),300(Dir),'//
c     &		'305(Dir),311(Dir),317(Dir),325(Dir),332(Dir),'//
c     &		'368(Dir),Qc Code'
C====================END OF HEADER==================================





C======OPEN A FILE TO WRITE THE COSINE-CORRECTED VOLTAGES/OUTPUT=========
       open(unit=10,file='mfrsr_cc.txt',
     1 status='unknown')
       open(unit=15,file='mfrsr_raw.txt',
     1 status='unknown')     
c
       open(unit=7,file='testing_date_up.txt',
     1 status='unknown')      
C====================================================================


C====================================================================
C==============OPEN ADN READ RAW VOLTAGE DATA FILE===================

      open(unit=11,file='uvmfr_582_20100506_20101215.txt',
     1  status='old',form='formatted')
        read(11,*)((rawvol(i,j),j=1,31),i=1,nobs)

C====================================================================
C	CALCULATION OF DAY,MONTH, AND YEAR FROM THE 1ST COLUMN OF RAW VOLTAGE DATA FILE
C	Number of years since 1900 (up to 2009)	=	110
C	Numher of leap year in that 110 years	=	27 
C       (1900 is not leap year)
C	Numher of non-leap year in that 110 years=	83
C	Numher of leap year days		=	27*366=9882
C	Numher of non-leap year days		=	83*365=30295

C	Total number of days till end of 2009	=	9882+30295=40177

c	40303 is the first day in the UV-MFRSR 582 data file
C	Number of days in year 2010		=	40303-40177 = 126
C	May 6th, 2010 is the first day of measurements with UV-MFRSR 582 (Hampton Univ. Instrument)

C      1                365             40177          40177+365
C   01/01/1900.......12/31/1900.......12/31/2009......12/31/2010

      open(unit=14,file='NTHDAY_TABLE_IDL.txt',
     1  status='old',form='formatted')
        read(14,*)((nthday_table(i,j),i=1,366),j=1,113)
        
C     ydate means the julian day for the last day of each year
      do k=1,113
        ydate(k)=nthday_table(366,k)
        if(ydate(k).eq.-9999) ydate(k)=nthday_table(365,k)
      enddo

      open(unit=12,file='CALENDER_NONLEAPYEAR.txt',
     1  status='old',form='formatted')
        read(12,*)((doy_table(i,j),j=1,13),i=1,31)

	do i=1,nobs
		nthday_round=rawvol(i,1)-mod(rawvol(i,1),1)
		fracday=mod(rawvol(i,1),1)
                do 30, j=1, 122
                  if(ydate(j).gt.nthday_round)then
                    foy=ydate(j-1)
                    GOTO 40
                  endif
30              continue
40              continue
                jday(i)=rawvol(i,1)-fracday-foy + 1.
		jday_frac(i)=jday(i)+fracday

C======================================================
C               NTHDAY_TABLE TO DOY CONNVERSION
                do j=1,366
                   do k=1,113
                      if(nthday_round.eq.nthday_table(j,k))then
                        year(i)=1899+k
                        doy(i)=j
                      endif
                   enddo
                enddo

C               DAY OF YEAR O MONTH/DATE CONVERSION
                do j=1,31
                   do k=2,13
                      if(doy(i).eq.doy_table(j,k))then
                        month(i)=k-1
                        date(i)=doy_table(j,1)     
                      endif
                   enddo
                enddo

		hour(i)=fracday*24-mod(fracday*24,1.0)
                mins(i)=mod(fracday*24,1.0)*60-
     1                  mod(mod(fracday*24,1.0)*60,1.0)
                secs(i)=mod(mod(fracday*24,1.0)*60,1.0)*60
		
		if(secs(i).eq.59)then
		   mins(i)=mins(i)+1
		   if(mins(i).eq.60)then
		     hour(i)=hour(i)+1
		     mins(i)=0
		     if(hour(i).ge.24)then
		       write(*,*)hour(i),mins(i),secs(i)
		       stop
		     endif
		   endif
	           secs(i)=0
		endif

		fracday=0.0

        write(7,'(I4.2,1x,I2.2,1x,I2.2,1x,I2.2,1x,I2.2,1x,I2.2)')
     &  year(i),month(i),date(i),hour(i),mins(i),secs(i)

	enddo	
C======================================================	

C====================OPEN AND READ COSINE CORRECTION TABLE==================
      open(unit=12,file='COSTAB_00582_034_2010B.txt',
     1  status='old',form='formatted')
      read(12,*)((cos_tab(i,j),j=1,16),i=1,358)	
C===========================================================================

C=================================================================================================
C==SOLAR EPHEMERIS TO CALCULATE SOLAR ZENITH AND AZIMUTH ANGLES FOR GIVEN DAY, TIME, AND STATION==
C==THE SOLAR EPHEMRIS CALCULATION IS ADOPTED FROM SBDART MODEL (P Ricchiazzi ET AL.)==============
	 data nday/
     &     1,   6,  11,  16,  21,  26,  31,  36,  41,
     &     46,  51,  56,  61,  66,  71,  76,  81,  86,
     &     91,  96, 101, 106, 111, 116, 121, 126, 131,
     &     136, 141, 146, 151, 156, 161, 166, 171, 176,
     &     181, 186, 191, 196, 201, 206, 211, 216, 221,
     &     226, 231, 236, 241, 246, 251, 256, 261, 266,
     &     271, 276, 281, 286, 291, 296, 301, 306, 311,
     &     316, 321, 326, 331, 336, 341, 346, 351, 356,
     &     361, 366/

 	data eqt/
     &     -3.23, -5.49, -7.60, -9.48,-11.09,-12.39,-13.34,-13.95,
     &     -14.23,-14.19,-13.85,-13.22,-12.35,-11.26,-10.01, -8.64,
     &     -7.18, -5.67, -4.16, -2.69, -1.29, -0.02,  1.10,  2.05,
     &     2.80,  3.33,  3.63,  3.68,  3.49,  3.09,  2.48,  1.71,
     &     0.79, -0.24, -1.33, -2.41, -3.45, -4.39, -5.20, -5.84,
     &     -6.28, -6.49, -6.44, -6.15, -5.60, -4.82, -3.81, -2.60,
     &     -1.19,  0.36,  2.03,  3.76,  5.54,  7.31,  9.04, 10.69,
     &     12.20, 13.53, 14.65, 15.52, 16.12, 16.41, 16.36, 15.95,
     &     15.19, 14.09, 12.67, 10.93,  8.93,  6.70,  4.32,  1.86,
     &     -0.62, -3.23/

      	data dec/
     &     -23.06,-22.57,-21.91,-21.06,-20.05,-18.88,-17.57,-16.13,
     &     -14.57,-12.91,-11.16, -9.34, -7.46, -5.54, -3.59, -1.62,
     &     0.36,  2.33,  4.28,  6.19,  8.06,  9.88, 11.62, 13.29,
     &     14.87, 16.34, 17.70, 18.94, 20.04, 21.00, 21.81, 22.47,
     &     22.95, 23.28, 23.43, 23.40, 23.21, 22.85, 22.32, 21.63,
     &     20.79, 19.80, 18.67, 17.42, 16.05, 14.57, 13.00, 11.33,
     &     9.60,  7.80,  5.95,  4.06,  2.13,  0.19, -1.75, -3.69,
     &     -5.62, -7.51, -9.36,-11.16,-12.88,-14.53,-16.07,-17.50,
     &     -18.81,-19.98,-20.99,-21.85,-22.52,-23.02,-23.33,-23.44,
     &     -23.35,-23.06/

	pi = 3.141592654
	dtor=pi/180.0
	degpday=360./365.242 
	E_CCen=0.01671        
	dayph=2.0

C	LATITUDE AND LONGITUDE OF STATION (AS GIVEN IN THE AERONET DATA FILE)
	alat=38.992
	alon=-76.840

      do i=1,nobs
        zenith(i)=0.00
	azimuth(i)=0.00
      enddo           
      
      do j=1,nobs
      	dd=mod(jday(j)-1,365)+1

      do 10 i=1,74
        if(nday(i) .gt. dd ) goto 20
 10   	continue
 20   	continue
      	frac=(dd-nday(i-1))/(nday(i)-nday(i-1))
      	eqtime=eqt(i-1)*(1.-frac)+frac*eqt(i)
      	decang=dec(i-1)*(1.-frac)+frac*dec(i)
      	declenation(j)=decang
      	sunlat=decang

c      	time=rawvol(j,2)*24
      	time=mod(rawvol(j,1),1.0)*24
      	sunlon=-15.*(time-12.+eqtime/60.)


      	t0=(90.-alat)*dtor
      	t1=(90.-sunlat)*dtor
      	p0=alon*dtor
      	p1=sunlon*dtor
      	zz=cos(t0)*cos(t1)+sin(t0)*sin(t1)*cos(p1-p0)

      	xx=sin(t1)*sin(p1-p0)
      	yy=sin(t0)*cos(t1)-cos(t0)*sin(t1)*cos(p1-p0)
      	azimuth(j)=atan2(xx,yy)/dtor
      	zenith(j)=acos(zz)/dtor
      	orig_zenith(j)=acos(rawvol(j,2))*180/pi
      	soldist(j)=1.0-E_CCen*cos(degpday*(dd-dayph)*dtor)

C=====CONVERSION OF AZIMUTH FROM -180 TO 180 FORMAT TO 0 TO 360 FORMAT===
      if(azimuth(j).ge.0.and.azimuth(j).le.180)then
        azimuth(j)=azimuth(j)
      elseif(azimuth(j).ge.-180.and.azimuth(j).lt.0)then
        azimuth(j)=azimuth(j)+360
      endif


      enddo
C====================================================================================================
C====================================================================================================


C==============================INTERPOLATION==========================================================
	indx=0

c	MFRSR Raw Data Loop
	do i=1,nobs
	if(rawvol(i,11).gt.0.0)then
		 

		indx=indx+1
                  do wv=1,7
                     do k=1,90
              		zenithN(k)=abs(cos_tab(k,1))
                        zenithS(k)=abs(cos_tab(k+89,1))
                        zenithE(k)=abs(cos_tab(k+179,1))
                        zenithW(k)=abs(cos_tab(k+268,1))
        
                        N_CC(k)=cos_tab(k,wv+2)
                        S_CC(k)=cos_tab(k+89,wv+2)

                        E_CC(k)=cos_tab(k+179,wv+2)
                        W_CC(k)=cos_tab(k+268,wv+2)
                     enddo


		if(azimuth(i).ge.0.and.azimuth(i).lt.90)then
		  phi1=0
                  phi2=90		  
                     do k=1,90
                     	zenith1(k)=zenithN(k)
                     	cc_table1(k)=N_CC(k)

                     	zenith2(k)=zenithE(k)
                     	cc_table2(k)=E_CC(k)
                     enddo

		elseif(azimuth(i).ge.90.and.azimuth(i).lt.180)then
		  phi1=90
		  phi2=180
                     do k=1,90		  
                     	zenith1(k)=zenithE(k)
                     	cc_table1(k)=E_CC(k)

                     	zenith2(k)=zenithS(k)
                     	cc_table2(k)=S_CC(k)
                     enddo

		elseif(azimuth(i).ge.180.and.azimuth(i).lt.270)then
		  phi1=180
		  phi2=270
                     do k=1,90		  		
                     	zenith1(k)=zenithS(k)
                     	cc_table1(k)=S_CC(k)

                     	zenith2(k)=zenithW(k)
                     	cc_table2(k)=W_CC(k)
                     enddo

		elseif(azimuth(i).ge.270.and.azimuth(i).lt.360)then
		  phi1=270
		  phi2=360		   
                     do k=1,90		  		
                     	zenith1(k)=zenithW(k)
                     	cc_table1(k)=W_CC(k)

                     	zenith2(k)=zenithN(k)
                     	cc_table2(k)=N_CC(k)
                     enddo
		endif

C================CORRECTION FOR THE TILT=====================================
C Alexandrov et al. (2007), APPLIED OPTICS, Vol. 46, No. 33, 20 November 2007

	tilt_NS=0.0
	tilt_EW=0.0
	zenith_new(i)=acos(cos(zenith(i)*pi/180)*cos(tilt_NS*pi/180)
     &	+(sin(zenith(i)*pi/180)*sin(tilt_NS*pi/180)*
     &	cos((azimuth(i)-tilt_EW)*pi/180)))*180/pi

	dummy=rawvol(i,wv+24)
	rawvol(i,wv+24)=rawvol(i,wv+24)*rawvol(i,2)
     &			/cos(zenith_new(i)*pi/180)
c	write(8,*),hour(i),dummy,rawvol(i,wv+24)
	if(wv.eq.1)then
	write(8,'(I4.2,1x,I2.2,1x,I2.2,1x,4(F10.4,1x)'),month(i),date(i),
     &	hour(i),orig_zenith(i),zenith(i),zenith_new(i),azimuth(i)
	write(9,*),month(i),date(i),hour(i),dummy,rawvol(i,wv+24)
        endif

C================================================================
c	zenith_calc(i)=zenith(i)
	zenith(i)=zenith_new(i)		
		
		

C	FINDING THETA RANGE BETWEEN WHICH THE MEASURED SOLAR ZENITH ANGLE FALLS
	call thetarange(zenith(i),zenithN,theta1,theta2)


C	COSINE CORRECTION INTERPOLATION BETWEEN TWO ZENITH ANGLES
	call interpol(zenith(i),theta1,theta2,zenith1,cc_table1,
     & 	      		ccintptheta1)
	call interpol(zenith(i),theta1,theta2,zenith2,cc_table2,
     & 			ccintptheta2)


C================INTEPOLATION BETWEEN TWO AZIMUTH ANGLES==============
	ccintp=ccintptheta1+(ccintptheta2-ccintptheta1)/
     &	       (phi2-phi1)*(azimuth(i)-phi1)


C================COMPUTATION OF CORRECTED VOLTAGES==============
	diff_tot_ratio=rawvol(i,wv+17)/rawvol(i,wv+10)
	v_total=rawvol(i,wv+10)

	vbias=0.0
         
C       Ft is the composite or total correction factor

        ft=1/(((1-diff_tot_ratio)/ccintp)+
     &	  ((diff_tot_ratio-(vbias/v_total))/fdiso(wv)))

	if(rawvol(i,wv+10).gt.0)then
           vt_corr(i,wv)=v_total/ft
           vdiff_corr(i,wv)=rawvol(i,wv+17)/fdiso(wv)
           vdirn_corr(i,wv)=rawvol(i,wv+24)/ccintp
           vt(i,wv)=v_total
           vdiff(i,wv)=rawvol(i,wv+17)
           vdirn(i,wv)=rawvol(i,wv+24)

	elseif(rawvol(i,wv+10).le.0)then
       	   vt_corr(i,wv)=0.00
           vdirn_corr(i,wv)=0.00
           vdiff_corr(i,wv)=0.00
           vt(i,wv)=0.00
           vdiff(i,wv)=0.00
           vdirn(i,wv)=0.00
	endif

	enddo

	airmass(i)=1/cos(zenith(i)*pi/180)
	orig_airmass(i)=1/cos(orig_zenith(i)*pi/180)
	elevation(i)=-999.0
	
		if(zenith(i).lt.89)then
		write(10,'(2(a,1x),(I4.2,1x,I2.2,1x,I2.2),1x, 
     &          (I2.2,1x,I2.2,1x,I2.2),1x,29(F10.4,1x))')
     &		site,instnum,year(i),month(i),date(i),hour(i),
     &		mins(i),secs(i),doy(i),vt_corr(i,1),vt_corr(i,2),
     &		vt_corr(i,3),vt_corr(i,4),vt_corr(i,5),vt_corr(i,6),
     &		vt_corr(i,7),vdiff_corr(i,1),vdiff_corr(i,2),
     &		vdiff_corr(i,3),vdiff_corr(i,4),vdiff_corr(i,5),
     &		vdiff_corr(i,6),vdiff_corr(i,7),vdirn_corr(i,1),
     &		vdirn_corr(i,2),vdirn_corr(i,3),vdirn_corr(i,4),
     &		vdirn_corr(i,5),vdirn_corr(i,6),vdirn_corr(i,7),
     &		azimuth(i),elevation(i),zenith(i),declenation(i),
     &		airmass(i),soldist(i),rawvol(i,25)
		endif
		
		if(orig_zenith(i).lt.89)then
		write(15,'(2(a,1x),(I4.2,1x,I2.2,1x,I2.2),1x,
     &          (I2.2,1x,I2.2,1x,I2.2),1x,29(F10.4,1x))')
     &		site,instnum,year(i),month(i),date(i),hour(i),
     &		mins(i),secs(i),doy(i),vt(i,1),vt(i,2),
     &		vt(i,3),vt(i,4),vt(i,5),vt(i,6),
     &		vt(i,7),vdiff(i,1),vdiff(i,2),
     &		vdiff(i,3),vdiff(i,4),vdiff(i,5),
     &		vdiff(i,6),vdiff(i,7),vdirn(i,1),
     &		vdirn(i,2),vdirn(i,3),vdirn(i,4),
     &		vdirn(i,5),vdirn(i,6),vdirn(i,7),
     &		azimuth(i),elevation(i),orig_zenith(i),declenation(i),
     &		orig_airmass(i),soldist(i),rawvol(i,25)
		endif
		
		
c	End of Loop for UV-MFRSR Data
	endif
	enddo

      stop
      end

C==========================================================
C==========================================================
C	SUBROUTINES

	subroutine thetarange(anglex,angleccx,angle1,angle2)
	real*4 anglex, angleccx(90), angle1, angle2
	integer i

		do i=1,90
		   if(abs(anglex-angleccx(i)).eq.0.0)then
		      angle1=angleccx(i)
		      angle2=angleccx(i)
		   endif
			   
		   if(abs(anglex-angleccx(i)).lt.1.0)then

		      angle1=angleccx(i)
		      angle2=angleccx(i)+1
		      
                  endif
		   
		enddo
	return
	end



       subroutine interpol(anglex,angle1,angle2,angleccx,
     1                     ccx,ccintpx)
       real*4 anglex, ccx(90), angle1, angle2, angleccx(90)
       real*4 ccintpx
       real*4 cc1,cc2
       do i =1, 90
         if(angleccx(i).eq.angle1)then
           cc1=ccx(i)
         elseif(angleccx(i).eq.angle2)then
           cc2=ccx(i)
         endif
       enddo

       ccintpx=cc1+(cc2-cc1)*(anglex-angle1)

       return
       end
