ozone=350.0		; [DU]
;ozone=300.0		; [DU]
pres_rel=1.0           ; Pressure, atm
airmass=2.0		; airmass (molecular)


print,'>get_spectral'
mode='print'
;mode='screen'

read,'input 1 to skip reading ETS: ',iskip
if iskip eq 1 then goto,skip


;	I. READ MONOCHOMATIC VACUUM x-sections: V217/coe.dat
;   	Monochromatic x-sections: Bass and Paur 
;		V8 extended beyong 410nm with V7
mlt=2106 & mszat=0 &  read_coe, './BSBR_V8.DAT.extended', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;               V8
;mlt=1601 & mszat=0 &  read_coe, '/BSBR_V8.DAT.ref', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;		V7
;mlt=1075 & mszat=0 &  read_coe, './BSBR_V7.DAT', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as: '../TOMRAD/v2.22/coe.dat.old', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 

;	Ia read F0 at vac solar wavelengths
read_solar,'./mayer_vac_ipmmi.txt', 275, l_solv,ml_solv,solv

;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
c0v_s      = dblarr(ml_solv)
c1v_s      = dblarr(ml_solv)
c2v_s      = dblarr(ml_solv)
betv_s     = dblarr(ml_solv)
rhov_s     = dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)
betv_s(*) = interpol(betv_t,lv_t,l_solv)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)

skip:

;       actual air wavelengths [nm] of MFRSR #271 measured in 2002:
; w_air=[299.758,305.408,311.485,317.638,325.498,332.558,367.906]
;       schifted to vac  wavelengths [nm] of MFRSR #271 (see airvac.pro )
; w_vac=[299.845,305.497,311.575,317.730,325.592,332.654,368.011]


;					PLOT
if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/color,/landscape,filename='GSFC_F271_SRF.ps'
;set_plot,'PS' & device,/color,/landscape,filename='GSFC_F271_SRF'+chan+'.ps'
endelse

;!p.multi=[0,3,2]

;get_srf271,'368nm',w368_vac,f368,err368 		; IIa. get SRF of MFRSR #271 (vac)
;plot_srf,ozone,pres_rel,airmass,mode,'368nm',363,372,w368_vac,f368,err368,l_solv,ml_solv,solv,betv_s,c0v_s,c1v_s,c2v_s
get_srf271,'332nm',w332_vac,f332,err332 		; IIa. get SRF of MFRSR #271 (vac)
plot_srf,ozone,pres_rel,airmass,mode,'332nm',328,337,w332_vac,f332,err332,l_solv,ml_solv,solv,betv_s,c0v_s,c1v_s,c2v_s

;get_srf271,'325nm',w325_vac,f325,err325 		; IIa. get SRF of MFRSR #271 (vac)
;plot_srf,ozone,pres_rel,airmass,mode,'325nm',322.0,330.0,w325_vac,f325,err325,l_solv,ml_solv,solv,betv_s,c0v_s,c1v_s,c2v_s
;
;get_srf271,'317nm',w317_vac,f317,err317 		; IIa. get SRF of MFRSR #271 (vac)
;plot_srf,ozone,pres_rel,airmass,mode,'317nm',314,322,w317_vac,f317,err317,l_solv,ml_solv,solv,betv_s,c0v_s,c1v_s,c2v_s
;get_srf271,'311nm',w311_vac,f311,err311 		; IIa. get SRF of MFRSR #271 (vac)
;plot_srf,ozone,pres_rel,airmass,mode,'311nm',307,316,w311_vac,f311,err311,l_solv,ml_solv,solv,betv_s,c0v_s,c1v_s,c2v_s
;get_srf271,'305nm',w305_vac,f305,err305 		; IIa. get SRF of MFRSR #271 (vac)
;plot_srf,ozone,pres_rel,airmass,mode,'305nm',301,310,w305_vac,f305,err305,l_solv,ml_solv,solv,betv_s,c0v_s,c1v_s,c2v_s
;get_srf271,'300nm',w300_vac,f300,err300 		; IIa. get SRF of MFRSR #271 (vac)
;plot_srf,ozone,pres_rel,airmass,mode,'300nm',295,305,w300_vac,f300,err300,l_solv,ml_solv,solv,betv_s,c0v_s,c1v_s,c2v_s


if mode ne 'screen' then device,/close

stop
end

