pro get_srfw,ihead,chan,w_vac,srf,err_srf

;			INPUT
;ihead -  head #
;chan  - channel identifier

;			OUTPUT
;w_vac - wavelengths of srf measurements shifted to vac
;srf   - measured srf for specific head and chan
;err   - error of measured SRF

;		MODIFIED
;	11/20/2012 MFRSR-582 is added 
;       11/19/12 : to read spectral calibration files from UV-MFRSR582 as measured at CUCF in Jan 2010
;	02/24/05 : to read AERONET filter function at 440nm for ihead=527

;Date: Thu, 8 Jul 2004 10:38:30 -0600 (MDT)
;From: Gwen Scott <gwen@uvb.nrel.colostate.edu>
;To: labow@qhearts.gsfc.nasa.gov
;Subject: Re: shadowband head #391
;Hi Gordon,
;You can download it from our website.
;Just go to "Stations/Data", then choose "Instrument Characteristics", then
;"Filter Function Plots."
;The site, Greenbelt MD, will be more towards the end of the sitelist, since
;it is a research site.  Any date head 391 was located at Goddard should
;work, but I just tried Apr 7, 2004.  Once you get the plots, you can
;choose "Download Data" to get the spectral response data file.



CASE ihead OF 

271:	begin  & file= '/home/krotkov/SPIE04/SPEC/SRF/27120030707_fil.txt' & n_rows=76 & skip_rows=1 
	wmin300_air=297.0 & wmax300_air=303.0		; 300nm
	wmin305_air=302.6 & wmax305_air=308.7		; 305nm
	wmin311_air=308.0 & wmax311_air=314.5		; 311nm
	wmin317_air=315.0 & wmax317_air=320.6		; 317nm
	wmin325_air=324.0 & wmax325_air=327.0		; 325nm
	wmin332_air=329.0 & wmax332_air=335.0		; 332nm
	wmin368_air=364.4 & wmax368_air=370.3		; 368nm
	end

390:	begin  & file= '/home/krotkov/SPIE04/SPEC/SRF/39120040407_fil.txt' & n_rows=68 & skip_rows=1	; old SRF for 391
	wmin300_air=297.1 & wmax300_air=302.6		; 391: 300nm
	wmin305_air=302.1 & wmax305_air=308.2		; 391: 305nm
	wmin311_air=307.0 & wmax311_air=313.7		; 391: 311nm
	wmin317_air=313.8 & wmax317_air=319.7		; 391: 317nm
	wmin325_air=321.0 & wmax325_air=327.4		; 391: 325nm
	wmin332_air=328.9 & wmax332_air=334.7		; 391: 332nm
	wmin368_air=365.4 & wmax368_air=369.6		; 391: 368nm
	end

391:	begin  & file= '/home/krotkov/UAE/SRF/MD22_391_20040401_fil.txt' & n_rows=69 & skip_rows=1	; new SRF for 391
	wmin300_air=297.1 & wmax300_air=302.6		; 391: 300nm
	wmin305_air=302.1 & wmax305_air=308.2		; 391: 305nm
	wmin311_air=307.0 & wmax311_air=313.7		; 391: 311nm
	wmin317_air=313.8 & wmax317_air=319.7		; 391: 317nm
	wmin325_air=321.0 & wmax325_air=327.4		; 391: 325nm
	wmin332_air=328.9 & wmax332_air=334.7		; 391: 332nm
	wmin368_air=366.1 & wmax368_air=369.6		; 391: 368nm
	end
;527:	begin  & file= '/home/krotkov/UVMFRSR527/SRF527/SRF_52720050217_041227' & n_rows=74 & skip_rows=1	; SRF for modified 527 
;527:	begin  & file= '/misc/sdproc4/krotkov/UVMFRSR527/SRF527/SRF_52720050217_041227' & n_rows=74 & skip_rows=1  ; SRF for modified 527 (directory is changed on 2011-11-09)
527:	begin  & file= '/misc/sdproc4/krotkov/UVMFRSR527_CALIBRATION/SRF527/SRF_52720050217_041227' & n_rows=74 & skip_rows=1  ; SRF for modified 527 (on 2012-02-03 krotkov changed the directory path)
;	NOTE: 300nm channel was replaced with 440nm channel !
	wmin440_air=430.1 & wmax440_air=450.0		; 527: 440nm (430-450nm)
	wmin305_air=302.3 & wmax305_air=308.4		; 527: 305nm
	wmin311_air=307.5 & wmax311_air=314.6		; 527: 311nm
	wmin317_air=314.7 & wmax317_air=320.3		; 527: 317nm
	wmin325_air=322.5 & wmax325_air=327.7		; 527: 325nm
	wmin332_air=329.0 & wmax332_air=335.6		; 527: 332nm
	wmin368_air=365.0 & wmax368_air=370.9		; 527: 368nm
	wmin380_air=370.1 & wmax380_air=390.0		; AERONET: 380nm channel 
	wmin340_air=335.9 & wmax340_air=344.4		; AERONET: 340nm channel 
	end
582:	begin  & file= '/misc/lgdat2/jwocky/jwscr1/krotkov/UVMFRSR582_CALIBRATION/SRF582/00582_022-2010C.SPR' & n_rows=1050 & skip_rows=37  ; SRF for modified 582
;	NOTE: 300nm channel was replaced with 440nm channel ; 368 was replaced with AERONET 380 and 332 was replace with AERONET 340 !
	wmin305_air=302.2 & wmax305_air=309.0		; 582: 305nm
	wmin311_air=307.5 & wmax311_air=314.6		; 582: 311nm
	wmin325_air=322.5 & wmax325_air=328.7		; 582: 325nm
	wmin332_air=328.8 & wmax332_air=335.6		; 582: 332nm
	wmin340_air=335.5 & wmax340_air=343.0		; 582: 340nm
	wmin380_air=375.0 & wmax380_air=382.0		; 582: 380nm
	wmin440_air=432.0 & wmax440_air=448.0		; 582: 440nm (430-450nm)
	end

ELSE:   begin &  print,'get_srfw: wrong head number:  ',ihead &  stop &  end
ENDCASE


if chan eq '300nm' then begin		; actually refers to 440nm channel !

if ihead eq 527 or 582 then begin &  print,'get_srfw:  no 300nm channel on 527 or 582 heads !' &  stop & endif


end else if chan eq '305nm' then begin
get_fltw582,file,wmin305_air,wmax305_air,15,2,n_rows,skip_rows,w_air,srf,err_srf
airvac,w_air,w_vac	; shift to vac wavelengths

end else if chan eq '311nm' then begin
get_fltw582,file,wmin311_air,wmax311_air,15,3,n_rows,skip_rows,w_air,srf,err_srf
airvac,w_air,w_vac	; shift to vac wavelengths

end else if chan eq '317nm' then begin
if ihead eq 582 then begin & print,'get_srfw:  no 317nm channel on 582 head !' &  stop &  endif

end else if chan eq '325nm' then begin
get_fltw582,file,wmin325_air,wmax325_air,15,5,n_rows,skip_rows,w_air,srf,err_srf
airvac,w_air,w_vac  ; shift to vac wavelengths

end else if chan eq '332nm' then begin
get_fltw582,file,wmin332_air,wmax332_air,15,6,n_rows,skip_rows,w_air,srf,err_srf
airvac,w_air,w_vac	; shift to vac wavelengths

end else if chan eq '340nm' then begin
if ihead ne 582 then begin & print,'get_srfw:  no 340nm channel on all heads except 582 !' &  stop &  endif
get_fltw582,file,wmin340_air,wmax340_air,15,4,n_rows,skip_rows,w_air,srf,err_srf
airvac,w_air,w_vac	; shift to vac wavelengths

end else if chan eq '380nm' then begin
if ihead ne 582 then begin & print,'get_srfw:  no 380nm channel on all heads except 582 !' &  stop &  endif
get_fltw582,file,wmin380_air,wmax380_air,15,7,n_rows,skip_rows,w_air,srf,err_srf
airvac,w_air,w_vac	; shift to vac wavelengths

end else if chan eq '368nm' then begin
if ihead eq 582 then begin & print,'get_srfw:  no 368nm channel on 582 head !' &  stop &  endif

end else if chan eq '440nm' then begin
;if ihead ne (582 or 527) then begin & print,'get_srfw:  no 440nm channel on heads before 527 !' &  stop &  endif
get_fltw582,file,wmin440_air,wmax440_air,15,1,n_rows,skip_rows,w_air,srf,err_srf
airvac,w_air,w_vac	; shift to vac wavelengths

endif



return
end
