

pro plot_result

;****ascii format*****
;year mn day
;gmt1 gmt2 r2   PRES
;AOT S_AOT    N0  N1
;V0_NORM ln(V0_N) sig
;C0   sigmaC0 TAU
;-C1   sigma  m1  m2
;C0(am)  sigC0(am) sig_fit(am), m1_am, m2_am,
;NO2_AERONET,NO2_true_mean, NO2_true_std  O3_AERONET  O3_true

file = 'F:\CLEO_work\MFRSR\krotkov\V0_20111010\uvmfr582\v0_norm368nmaeronet.clearno2'
readcol, file, yr, mn, da, gmt1, gmt2, r2, pres, aot, saot, n0, n1, V0_norm, ln_v0_n, sig, $
  c0, sigma_c0, tau, m_c1, sigma, m1, m2, c0_am, sigc0_am, sig_fit_am, m1_am, m2_am, no2_aeronet, no2_true_mean, no2_true_std,$
  o3_aeronet, o3_true, format='F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F,F'
num = n_elements(yr)
jul_date = julday(mn,da,yr)

!x.thick=3
!y.thick=4

;x0 = min(jul_date) & x1 = max(jul_date)
x0 = julday(1,1,2007) & x1 = max(jul_date)
device, decomposed=0
window, 1, xs=1200, ys=900
loadct, 39
A = FINDGEN(17) * (!PI*2/16.)
USERSYM, COS(A), SIN(A), /FILL, color=254
dummy=label_date(date_format='%Z-%N-%D')
plot, jul_date, ln_v0_n, psym=8, background=255, xmargin=[9,9],ymargin=[6,6], thick=0.8, charsize=1.1, charthick=1.5, $
  ytitle='ln(V0_N)', color=0, xtickformat='label_date', $
  XTICKUNITS='Years', xtickinterval=1, xminor=12, ystyle=1+8, yrange=[7.45,7.48], title='368 nm (SZA < 70)'
USERSYM, COS(A), SIN(A), /FILL, color=FSC_color('Blue')
axis, yaxis=1, /save, /data, charsize=1.2, ytitle='AOD', color=50, charthick=1.5, yrange=[0,1]
oplot, jul_date, aot, psym=8

stop

;format of output irradiance file (v0_chan_oneday.pro, v0_chan_alldays.pro)
;Ins year  mn day hh mm  ss
;total    diffuse  dir_nor  V0_RAW   r2     sza     am      abs_pr   OZONE   LER   AOT_AER    daot   saot
;AOT_MFRSR TAU_RAY   TAU_OZ    TAU_TOT   L_DIR     L_eff      NO2,    NO2err,  NO2delta_time  NO2_aeronet
file2 = 'F:\CLEO_work\MFRSR\krotkov\V0_20111010\uvmfr582\irradcal440nmaeronet.clearno2'
readcol, file2, Ins2, year2, mn2, day2, hh2, mm2,  ss2, tot, diffuse,dir_nor,V0_RAW, r2,sza,am,abs_pr,OZONE,LER,AOT_AER,daot,saot, $
  format='(f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f,f)'
jul_date = julday(mn2,day2,year2,hh2,mm2,ss2)
dhour = hh2 +  mm2/60. + hh2/3600.

device, decomposed=0
window, 2, xs=1200, ys=900
loadct, 39
A = FINDGEN(17) * (!PI*2/16.)
USERSYM, COS(A), SIN(A), /FILL, color=cgcolor('Black')
dummy=label_date(date_format='%Z-%N-%D')
plot, jul_date, tot, psym=8, background=255, xmargin=[9,9],ymargin=[6,6], thick=0.8, charsize=1.1, charthick=1.5, $
  ytitle='Total', color=0, xtickformat='label_date', $
  XTICKUNITS='Years', xtickinterval=1, xminor=12, yrange=[min(diffuse)-10.,max(tot)-20.];, title='368 nm (SZA < 70)'
USERSYM, COS(A), SIN(A), /FILL, color=cgcolor('Blue')
oplot, jul_date,diffuse,psym=8
USERSYM, COS(A), SIN(A), /FILL, color=cgcolor('Red')
oplot, jul_date,dir_nor,psym=8


ref = where(year2 eq 2010 and mn2 eq 5 and day2 eq 30)
jul_date = jul_date(ref) & tot = tot(ref) & diffuse = diffuse(ref) & dir_nor = dir_nor(ref) & dhour = dhour(ref)
device, decomposed=0
window, 3, xs=1200, ys=900
loadct, 39
A = FINDGEN(17) * (!PI*2/16.)
USERSYM, COS(A), SIN(A), /FILL, color=cgcolor('Black')
plot, dhour, tot, psym=-8, background=255, xmargin=[9,9],ymargin=[6,6], thick=0.8, charsize=1.1, charthick=1.5, $
  ytitle='440 nm', color=cgcolor('Black'), $
  yrange=[0.,max(tot)+20.], title='05/30/2010 from "irradcal440nmaeronet.clearno2"', LINESTYLE=3, xtitle='Decimal hour'
USERSYM, COS(A), SIN(A), /FILL, color=cgcolor('Blue')
oplot, dhour,diffuse,psym=-8, color=cgcolor('Blue'), LINESTYLE=3
USERSYM, COS(A), SIN(A), /FILL, color=cgcolor('Red')
oplot, dhour,dir_nor,psym=-8, color=cgcolor('Red'), LINESTYLE=3

items = ['total','diffuse','dir_nor']
lines=[3,3,3] & colors=[cgcolor('black'),cgcolor('Blue'),cgcolor('Red')]
al_legend, items, psym=[-16,-16,-16], linestyle=lines, color=colors, /normal, box=0, textcolors=colors, /right

stop

end
